# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from ._enums import *

__all__ = [
    'ClusterServiceAksClusterDataArgs',
    'ClusterServiceNexusAksClusterDataArgs',
    'QualifiedComponentDeploymentParametersArgs',
]

@pulumi.input_type
class ClusterServiceAksClusterDataArgs:
    def __init__(__self__, *,
                 custom_location_id: pulumi.Input[str],
                 type: pulumi.Input[str]):
        """
        AKS Cluster specific data.
        :param pulumi.Input[str] custom_location_id: Custom Location resource ID
        :param pulumi.Input[str] type: Cluster Type Definitions
               Expected value is 'Aks'.
        """
        pulumi.set(__self__, "custom_location_id", custom_location_id)
        pulumi.set(__self__, "type", 'Aks')

    @property
    @pulumi.getter(name="customLocationId")
    def custom_location_id(self) -> pulumi.Input[str]:
        """
        Custom Location resource ID
        """
        return pulumi.get(self, "custom_location_id")

    @custom_location_id.setter
    def custom_location_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "custom_location_id", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        Cluster Type Definitions
        Expected value is 'Aks'.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)


@pulumi.input_type
class ClusterServiceNexusAksClusterDataArgs:
    def __init__(__self__, *,
                 custom_location_id: pulumi.Input[str],
                 type: pulumi.Input[str]):
        """
        Nexus AKS Cluster specific data.
        :param pulumi.Input[str] custom_location_id: Custom Location resource ID
        :param pulumi.Input[str] type: Cluster Type Definitions
               Expected value is 'NexusAks'.
        """
        pulumi.set(__self__, "custom_location_id", custom_location_id)
        pulumi.set(__self__, "type", 'NexusAks')

    @property
    @pulumi.getter(name="customLocationId")
    def custom_location_id(self) -> pulumi.Input[str]:
        """
        Custom Location resource ID
        """
        return pulumi.get(self, "custom_location_id")

    @custom_location_id.setter
    def custom_location_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "custom_location_id", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        Cluster Type Definitions
        Expected value is 'NexusAks'.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)


@pulumi.input_type
class QualifiedComponentDeploymentParametersArgs:
    def __init__(__self__, *,
                 type: pulumi.Input[str],
                 parameters: Optional[pulumi.Input[str]] = None,
                 secrets: Optional[pulumi.Input[str]] = None):
        """
        Containerized Network Function (CNF) Qualified Deployment Parameters
        :param pulumi.Input[str] type: Federation Type
        :param pulumi.Input[str] parameters: Deployment Parameters
        :param pulumi.Input[str] secrets: Deployment secrets
        """
        pulumi.set(__self__, "type", type)
        if parameters is not None:
            pulumi.set(__self__, "parameters", parameters)
        if secrets is not None:
            pulumi.set(__self__, "secrets", secrets)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        Federation Type
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def parameters(self) -> Optional[pulumi.Input[str]]:
        """
        Deployment Parameters
        """
        return pulumi.get(self, "parameters")

    @parameters.setter
    def parameters(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "parameters", value)

    @property
    @pulumi.getter
    def secrets(self) -> Optional[pulumi.Input[str]]:
        """
        Deployment secrets
        """
        return pulumi.get(self, "secrets")

    @secrets.setter
    def secrets(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "secrets", value)


