# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._enums import *

__all__ = ['WorkspaceManagerConfigurationArgs', 'WorkspaceManagerConfiguration']

@pulumi.input_type
class WorkspaceManagerConfigurationArgs:
    def __init__(__self__, *,
                 mode: pulumi.Input[Union[str, 'Mode']],
                 resource_group_name: pulumi.Input[str],
                 workspace_name: pulumi.Input[str],
                 workspace_manager_configuration_name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a WorkspaceManagerConfiguration resource.
        :param pulumi.Input[Union[str, 'Mode']] mode: The current mode of the workspace manager configuration
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[str] workspace_name: The name of the workspace.
        :param pulumi.Input[str] workspace_manager_configuration_name: The name of the workspace manager configuration
        """
        pulumi.set(__self__, "mode", mode)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        pulumi.set(__self__, "workspace_name", workspace_name)
        if workspace_manager_configuration_name is not None:
            pulumi.set(__self__, "workspace_manager_configuration_name", workspace_manager_configuration_name)

    @property
    @pulumi.getter
    def mode(self) -> pulumi.Input[Union[str, 'Mode']]:
        """
        The current mode of the workspace manager configuration
        """
        return pulumi.get(self, "mode")

    @mode.setter
    def mode(self, value: pulumi.Input[Union[str, 'Mode']]):
        pulumi.set(self, "mode", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="workspaceName")
    def workspace_name(self) -> pulumi.Input[str]:
        """
        The name of the workspace.
        """
        return pulumi.get(self, "workspace_name")

    @workspace_name.setter
    def workspace_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "workspace_name", value)

    @property
    @pulumi.getter(name="workspaceManagerConfigurationName")
    def workspace_manager_configuration_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the workspace manager configuration
        """
        return pulumi.get(self, "workspace_manager_configuration_name")

    @workspace_manager_configuration_name.setter
    def workspace_manager_configuration_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "workspace_manager_configuration_name", value)


class WorkspaceManagerConfiguration(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 mode: Optional[pulumi.Input[Union[str, 'Mode']]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 workspace_manager_configuration_name: Optional[pulumi.Input[str]] = None,
                 workspace_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        The workspace manager configuration
        Azure REST API version: 2023-06-01-preview.

        Other available API versions: 2023-07-01-preview, 2023-08-01-preview, 2023-09-01-preview, 2023-10-01-preview, 2023-12-01-preview.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union[str, 'Mode']] mode: The current mode of the workspace manager configuration
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[str] workspace_manager_configuration_name: The name of the workspace manager configuration
        :param pulumi.Input[str] workspace_name: The name of the workspace.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: WorkspaceManagerConfigurationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The workspace manager configuration
        Azure REST API version: 2023-06-01-preview.

        Other available API versions: 2023-07-01-preview, 2023-08-01-preview, 2023-09-01-preview, 2023-10-01-preview, 2023-12-01-preview.

        :param str resource_name: The name of the resource.
        :param WorkspaceManagerConfigurationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(WorkspaceManagerConfigurationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 mode: Optional[pulumi.Input[Union[str, 'Mode']]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 workspace_manager_configuration_name: Optional[pulumi.Input[str]] = None,
                 workspace_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = WorkspaceManagerConfigurationArgs.__new__(WorkspaceManagerConfigurationArgs)

            if mode is None and not opts.urn:
                raise TypeError("Missing required property 'mode'")
            __props__.__dict__["mode"] = mode
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["workspace_manager_configuration_name"] = workspace_manager_configuration_name
            if workspace_name is None and not opts.urn:
                raise TypeError("Missing required property 'workspace_name'")
            __props__.__dict__["workspace_name"] = workspace_name
            __props__.__dict__["etag"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:securityinsights/v20230401preview:WorkspaceManagerConfiguration"), pulumi.Alias(type_="azure-native:securityinsights/v20230501preview:WorkspaceManagerConfiguration"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:WorkspaceManagerConfiguration"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:WorkspaceManagerConfiguration"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:WorkspaceManagerConfiguration"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:WorkspaceManagerConfiguration"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:WorkspaceManagerConfiguration"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:WorkspaceManagerConfiguration")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(WorkspaceManagerConfiguration, __self__).__init__(
            'azure-native:securityinsights:WorkspaceManagerConfiguration',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'WorkspaceManagerConfiguration':
        """
        Get an existing WorkspaceManagerConfiguration resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = WorkspaceManagerConfigurationArgs.__new__(WorkspaceManagerConfigurationArgs)

        __props__.__dict__["etag"] = None
        __props__.__dict__["mode"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        return WorkspaceManagerConfiguration(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def etag(self) -> pulumi.Output[str]:
        """
        Resource Etag.
        """
        return pulumi.get(self, "etag")

    @property
    @pulumi.getter
    def mode(self) -> pulumi.Output[str]:
        """
        The current mode of the workspace manager configuration
        """
        return pulumi.get(self, "mode")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

